#ifndef lint
static char	*RcsId = "$Header: sldetach.c,v 1.1 84/10/04 12:56:27 rick Exp $";
#endif !lint

#include <stdio.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>
#include <sys/mbuf.h>
#include <nlist.h>

#define	KERNEL
#include <net/route.h>
#include <netinet/in.h>

struct	rtentry route;

struct nlist nl[] = {
#define	N_RTHOST	0
	{ "_rthost" },
#define	N_RTNET		1
	{ "_rtnet" },
	"",
};

struct	ifreq ifr;

main(argc,argv)
char *argv[];
{
	register struct rtentry *rt;
	register struct mbuf *m;
	register int fd;
	struct mbuf mb;
	struct mbuf *routehash[RTHASHSIZ];
	struct sockaddr_in *sin;
	struct in_addr deladdr;
	int i, doinghost = 1, kmem;

	if (argc != 2) {
		fprintf(stderr,"usage: sldetach interface-name\n");
		exit(1);
	}

	fd = socket(AF_INET, SOCK_DGRAM, 0);
	if (fd < 0) {
		perror("sldetach: socket");
		exit(1);
	}
	strcpy(ifr.ifr_name,argv[1]);

	/* We must flush entries in the routing tables that go
	 * through this interface. The network code gets very
	 * upset when the interface is gone and it thinks it
	 * has a route through it.
	 */
	if (ioctl(fd, SIOCGIFDSTADDR, (caddr_t)&ifr) < 0) {
		perror("ioctl (SIOCGIFADDR)");
		exit(1);
	}

	sin = (struct sockaddr_in *)&ifr.ifr_dstaddr;
	deladdr = sin->sin_addr;

	nlist("/vmunix", nl);
	if (nl[N_RTHOST].n_value == 0) {
		printf("sldetach: \"rthost\", symbol not in namelist\n");
		exit(1);
	}
	if (nl[N_RTNET].n_value == 0) {
		printf("sldetach: \"rtnet\", symbol not in namelist\n");
		exit(1);
	}

	kmem = open("/dev/kmem", 0);
	if (kmem < 0) {
		perror("route: /dev/kmem");
		exit(1);
	}
	lseek(kmem, nl[N_RTHOST].n_value, 0);
	read(kmem, routehash, sizeof (routehash));
again:
	for (i = 0; i < RTHASHSIZ; i++) {
		if (routehash[i] == 0)
			continue;
		m = routehash[i];
		while (m) {
			lseek(kmem, m, 0);
			read(kmem, &mb, sizeof (mb));
			rt = mtod(&mb, struct rtentry *);
			sin = (struct sockaddr_in *)&rt->rt_gateway;
			if (deladdr.s_addr == sin->sin_addr.s_addr) {
				if (ioctl(fd, SIOCDELRT, (caddr_t)rt) < 0)
					perror("delete");
			}
			m = mb.m_next;
		}
	}
	if (doinghost) {
		lseek(kmem, nl[N_RTNET].n_value, 0);
		read(kmem, routehash, sizeof (routehash));
		doinghost = 0;
		goto again;
	}
	close(kmem);

	/* Now that the routes have been removed, we can actually
	 * delete the interface
	 */
	if (ioctl(fd, SIOCIFDETACH, (caddr_t)&ifr) < 0) {
		perror("ioctl (SIOCIFDETACH)");
		exit(1);
	}
}
